#include <iostream>
#include <fstream>

using namespace std;

int main()
{
	ifstream in("FLOAT.IN");
	int t;
	__int64 p,q;
	in>>t;
	for (int z=0;z<t;z++)
	{
		in>>p>>q;
		__int64 k=0;
		if(q<16777216) k=q-p+1;
		else 
		{
			if(p<16777216)
			{
				k=16777215-p+1;
				p=16777216;
			}
			k+=(q-p)/2;
			if(q%2!=0) k++;
			if(q-p==1) k=1;
		}
		
		cout<<k<<endl;
	}
	return 0;
}